;
; SelfEraser v1.00.NT (WIN NT), (c) 2002 by Dmitry Petrenko (demask@mail.ru)
;
; This sample demonstrates selferasing method by Win32 application.
; Target OS is Win NT.
;

.386p
.model flat,stdcall

        jumps

;===[ External API Declarations ]=========================================;

extrn	MessageBoxA:proc
extrn   GetModuleHandleA:proc
extrn   GetModuleFileNameA:proc
extrn	GetProcAddress:proc
extrn	GlobalAlloc:proc
extrn	GlobalFree:proc
extrn	GetCurrentProcessId:proc
extrn	EnumProcesses:proc
extrn	OpenProcess:proc
extrn	VirtualAllocEx:proc
extrn	VirtualFreeEx:proc
extrn	WriteProcessMemory:proc
extrn	CreateRemoteThread:proc
extrn	CloseHandle:proc
extrn	ExitProcess:proc

;===[ Data Section ]==============================================

.data

; Some constants

buff_size	equ	4096
ofs		equ     offset
NULL		equ     0
TRUE		equ	1
FALSE		equ	0

; Windows API constants

MAX_SINGLEFNAME         =   256
MB_OK                   =   0
GMEM_FIXED		=   0000h
GMEM_ZEROINIT		=   0040h
GPTR			=   (GMEM_FIXED or GMEM_ZEROINIT)
PAGE_READONLY		=   02h
PAGE_EXECUTE_READWRITE	=   40h
MEM_COMMIT		=   1000h
MEM_RESERVE		=   2000h
MEM_DECOMMIT		=   4000h
MEM_RELEASE		=   8000h
STANDARD_RIGHTS_REQUIRED=   000F0000h
SYNCHRONIZE		=   00100000h
PROCESS_CREATE_THREAD	=   0002h
PROCESS_VM_OPERATION	=   0008h
PROCESS_VM_READ		=   0010h
PROCESS_VM_WRITE	=   0020h
PROCESS_ALL_ACCESS	=   (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or 0FFFh)
ERROR_ACCESS_DENIED	=   5

; buffer for module path and file name

box_title       db      'Self-erasing algorythm demo (Win NT), '
		db	'(x) 2000 by PREDAt0R',0

; other data (variables)

dwOurProcessId	dd	?
hOurModule	dd	?
hKernel32Module	dd	?
lpBuffer	dd	?
lpThreadBase	dd	?
dwProcessesCnt	dd	?
dwThreadID	dd	?
hTargetProcess	dd	?
szKernelDll	db	'kernel32.DLL',0
szOpenProcess	db	'OpenProcess',0
szCloseHandle	db	'CloseHandle',0
szDeleteFile	db	'DeleteFileA',0
szExitThread	db	'ExitThread',0

;
; Erasing routine, run as a separate remote thread
; Entry: lpParameter:dword - contains parent process ID
;

remote_thread	proc	lpParameter:dword
		uses	esi

	; get address of 'pop eax' instruction
	call	get_ip
get_ip:	pop	esi
	; get handle of parent process (OpenProcess)
check_process_loop:
	mov	eax,[esi+ofs pOpenProcess-ofs get_ip]
	call	eax,STANDARD_RIGHTS_REQUIRED,FALSE,[lpParameter]
	or	eax,eax
	jz	process_terminated
	; (CloseHandle)
	push	eax
	mov	eax,[esi+ofs pCloseHandle-ofs get_ip]
	call	eax
	jmp	check_process_loop
	; delete file: try 10 times to delete ourself	
process_terminated:
	mov	ecx,10
delete_loop:
	push	ecx
	mov	eax,[esi+ofs pDeleteFile-ofs get_ip]
	lea	ecx,[esi+ofs szOurPathName-ofs get_ip]
	call	eax,ecx
	pop	ecx
	or	eax,eax
	jnz	exit_thread
	loopd	delete_loop
	; (ExitThread)
exit_thread:
	mov	eax,[esi+ofs pExitThread-ofs get_ip]
	call	eax,0
	ret

szOurPathName	dw	MAX_SINGLEFNAME dup (?)
pOpenProcess	dd	?
pCloseHandle	dd	?
pDeleteFile	dd	?
pExitThread	dd	?

remote_thread	endp

remote_thread_size	=	$-remote_thread

;===[ Code Section ]======================================================;

.code

main:

; Obtain information about KERNEL32.OpenProcess, CloseHandle, DeleteFileA
; and ExitThread functions addresses

	call	GetModuleHandleA,ofs szKernelDll
	or	eax,eax
	jz	shut_down_process_1
	mov	dword ptr [hKernel32Module],eax
	call	GetProcAddress,[hKernel32Module],ofs szOpenProcess
	mov	dword ptr [pOpenProcess],eax
	call	GetProcAddress,[hKernel32Module],ofs szCloseHandle
	mov	dword ptr [pCloseHandle],eax
	call	GetProcAddress,[hKernel32Module],ofs szDeleteFile
	mov	dword ptr [pDeleteFile],eax
	call	GetProcAddress,[hKernel32Module],ofs szExitThread
	mov	dword ptr [pExitThread],eax

; Get module file name and path

	call	GetCurrentProcessId
	mov	dword ptr [dwOurProcessId],eax
	call	GetModuleHandleA,NULL
	mov	dword ptr [hOurModule],eax		; save module handle
	call	GetModuleFileNameA,eax,ofs szOurPathName,MAX_SINGLEFNAME

; Display our message box

	call	MessageBoxA,NULL,ofs szOurPathName,ofs box_title,MB_OK

; Allocate 4kb of memory

	call	GlobalAlloc,GPTR,buff_size
	or	eax,eax
	jz	shut_down_process_1
	mov	dword ptr [lpBuffer],eax

; Enumerate runned processes

	call	EnumProcesses,[lpBuffer],buff_size,ofs dwProcessesCnt
	or	eax,eax
	jz	create_remote_thread_error_1
	shr	dword ptr [dwProcessesCnt],2

; Try to open next process with specified access rights

	mov 	ecx,dword ptr [lpBuffer]
open_process_loop:
	push	ecx
	; check if process belongs to us
	mov	eax,dword ptr [ecx]
	cmp	dword ptr [dwOurProcessId],eax
	je	continue_open_process_loop
	; open process
	call	OpenProcess,PROCESS_CREATE_THREAD or PROCESS_VM_OPERATION or\
		PROCESS_VM_WRITE or PROCESS_VM_READ,FALSE,eax
	or	eax,eax
	jnz	create_remote_thread
	pop	ecx
continue_open_process_loop:
	add	ecx,4
	dec	dword ptr [dwProcessesCnt]
	jnz	open_process_loop
	jmp	create_remote_thread_error_1

create_remote_thread:
	mov	dword ptr [hTargetProcess],eax

; WinNT: free space for our thread (in case we are restarting) and
; allocate a physical storage within the virtual address space of a
; target process (must have PROCESS_VM_OPERATION access rights)

	call	VirtualFreeEx,[hTargetProcess],NULL,0,MEM_RELEASE
	call	VirtualAllocEx,[hTargetProcess],NULL,remote_thread_size,\
		MEM_COMMIT or MEM_RESERVE,PAGE_EXECUTE_READWRITE

	pop	ecx
	or	eax,eax
	jz	continue_open_process_loop
	mov	dword ptr [lpThreadBase],eax

; Write a code of our remote thread at the allocated space (must have
; PROCESS_VM_WRITE and PROCESS_VM_OPERATION access rights)

	call	WriteProcessMemory,[hTargetProcess],[lpThreadBase],\
		ofs remote_thread,remote_thread_size,NULL
	or	eax,eax
	jz	create_remote_thread_error_2

; WinNT/98: create remote thread within the address space of a target process
; (must have PROCESS_CREATE_THREAD, PROCESS_VM_OPERATION, PROCESS_VM_WRITE and
; PROCESS_VM_READ access rights)

	call	CreateRemoteThread,[hTargetProcess],NULL,0,[lpThreadBase],\
		[dwOurProcessId],0,ofs dwThreadID
	or	eax,eax
	jz	create_remote_thread_error_2

; Free thread handle

	call	CloseHandle,eax
	jmp	shut_down_process_2

; Free allocated virtual space, display an error window, and shut down
; current process

create_remote_thread_error_2:
	call	VirtualFreeEx,[hTargetProcess],[lpThreadBase],MEM_RELEASE

create_remote_thread_error_1:
shut_down_process_2:
	call	GlobalFree,[lpBuffer]

shut_down_process_1:
	call	ExitProcess,0

end main
